//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "keiji"
#property link      "http://www.dr-ea.com/meta-blog/"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 2

#import "user32.dll"
int GetAncestor(int,int);
#import

#include <WinUser32.mqh>
#include <stdlib.mqh>

extern bool    SwitchEAs         = true;
extern int     NoTradeBeforeMin  = 20;
extern int     NoTradeAfterMin   = 30;
extern string  NoTradeFileName   = "NoTradeTimeV2.csv";

//other
string labelfont  = "Arial";
string labelfontB = "Arial Bold";

int subjectX         = 10;
int infoX            = 80;
int timedatasubjectX = 250;
int timedatainfoX    = 360;
int parasubjectX     = 540;
int parainfoX        = 670;

bool initialset;

//memo
string shortname;

int BeforSecond;
int AfterSecond;

datetime Now;
int      NextIndex=0;
datetime NoTradeData[];
int      NoTradeDataCount;
bool     NoData;

//+------------------------------------------------------------------+
//| initialization function                                          |
//+------------------------------------------------------------------+
int init()
  {
//----
   NoData     = false;
   initialset = false;
   shortname  = "   ";
   IndicatorShortName(shortname);
   
   BeforSecond = NoTradeBeforeMin * 60;
   AfterSecond = NoTradeAfterMin  * 60;
   
   SetNoTradeData();
   Now = TimeCurrent();
   IsNoTradeTime();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| deinitialization function                                        |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| start function                                                   |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(SwitchEAs)
   if(!IsDllsAllowed())
   {
      Alert("Check Allow DLL imports");
      return(0);
   }
   
   Now = TimeCurrent();
   
   
   //Object Set
   int y1 = 15, y2 = 0, y3 = 0;
   string objname, text;
   
   if(!initialset)
   {
      objname = "NowTimeSub";
      text    = "Now Time:";
      FuncLabelSet(objname, text, 10, labelfontB, White, subjectX, y1);
   }
   objname = "NowTime";
   text    = TimeToStr(Now, TIME_DATE|TIME_MINUTES);
   FuncLabelSet(objname, text, 10, labelfont, White, infoX, y1);
   
   if(!initialset)
   {
      objname = "LastDataSub";
      text    = "Last Time Data:";
      FuncLabelSet(objname, text, 10, labelfontB, White, timedatasubjectX, y2);
   }
   objname = "LastData";
   if(NoTradeData[NextIndex-1] <= 0 || NoData) text = "No Data";
   else text = TimeToStr(NoTradeData[NextIndex-1], TIME_DATE|TIME_MINUTES);
   FuncLabelSet(objname, text, 10, labelfont, White, timedatainfoX, y2);
   y2 += 15;
   
   if(!initialset)
   {
      objname = "NextDataSub";
      text    = "Next Time Data:";
      FuncLabelSet(objname, text, 10, labelfontB, White, timedatasubjectX, y2);
   }
   objname = "NextData";
   if(NoTradeData[NextIndex] <= 0 || NoData) text = "No Data";
   else text = TimeToStr(NoTradeData[NextIndex], TIME_DATE|TIME_MINUTES);
   FuncLabelSet(objname, text, 10, labelfont, White, timedatainfoX, y2);
   
   if(!initialset)
   {
      objname = "BeforeMinSub";
      text    = "NoTradeBeforeMin:";
      FuncLabelSet(objname, text, 10, labelfontB, White, parasubjectX, y3);
      objname = "BeforeMin";
      text    = DoubleToStr(NoTradeBeforeMin,0);
      FuncLabelSet(objname, text, 10, labelfont, White, parainfoX, y3);
      y3 += 15;
   
      objname = "AfterMinSub";
      text    = "NoTradeAfterMin:";
      FuncLabelSet(objname, text, 10, labelfontB, White, parasubjectX, y3);
      objname = "AfterMin";
      text    = DoubleToStr(NoTradeAfterMin,0);
      FuncLabelSet(objname, text, 10, labelfont, White, parainfoX, y3);
   }
   
   initialset = true;
   
   
   //Check Trade Time
   if(!NoData)
   {
      if(IsNoTradeTime())
      {
         FuncLabelSet("ZoneInfo","No Trade Time Zone", 10,labelfontB,Red,subjectX,0);
         if(SwitchEAs) if(IsExpertEnabled()) switchEA();
         return(0);
      }
   }
   
   
   //:::::::::::::::::::::::::::::
   //Trade Time Zone
   if(SwitchEAs) if(!IsExpertEnabled()) switchEA();
   FuncLabelSet("ZoneInfo","Trade Time Zone", 10,labelfontB,LightBlue,subjectX,0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//fanctions*****************************************************************************

void SetNoTradeData()
{
   int handle = FileOpen(NoTradeFileName, FILE_CSV | FILE_READ, ",");
   if(handle < 0)
   {
      Print("File " + NoTradeFileName + " not Open, the last error is ", ErrorDescription(GetLastError()));
      return(0);
   }
   else
   {
      //data count
      int cnt = 0;
      while(true)
      {
         FileReadString(handle);
         if(FileIsEnding(handle)) break;
         if(FileIsLineEnding(handle)) cnt++;
      }
      
      NoTradeDataCount = cnt-1;
      
      if(cnt == 1) NoData=true;
      else  //array set
      {
         NoData = false;
         ArrayResize(NoTradeData, NoTradeDataCount);
         ArrayInitialize(NoTradeData, 0);
         FileSeek(handle, 0, SEEK_SET);
         while(true) 
         {
            FileReadString(handle); //subject
            if(FileIsLineEnding(handle)) break;
         }
         for(int i=0; i<cnt-1; i++)
         {
            NoTradeData[i] = StrToTime(FileReadString(handle) + "." + FileReadString(handle) + "." + FileReadString(handle) +
                             " " + FileReadString(handle) + ":" + FileReadString(handle));
         }
         ArraySort(NoTradeData);
      }
      FileClose(handle);
   }
   //print data
   for(i=0; i<NoTradeDataCount; i++)
      Print("No Trade: ", TimeToStr(NoTradeData[i]-BeforSecond, TIME_DATE|TIME_MINUTES), " - ",
            TimeToStr(NoTradeData[i], TIME_DATE|TIME_MINUTES), " - ", TimeToStr(NoTradeData[i]+AfterSecond, TIME_DATE|TIME_MINUTES));
}

bool IsNoTradeTime()
{
   bool result = false;
   if(NextIndex < NoTradeDataCount)
   if(Now >= NoTradeData[NextIndex])
   {
      for(int i=NextIndex+1; i<=NoTradeDataCount; i++)
      {
         if(i == NoTradeDataCount)
         {
            NextIndex = NoTradeDataCount;
            break;
         }
         if(Now >= NoTradeData[i]) continue;
         NextIndex = i;
         break;
      }
   }
   if(NextIndex == NoTradeDataCount)
   if(Now >= NoTradeData[NextIndex-1] + AfterSecond)  //Data Fin
   {
      NoData = true;
      return(false);
   }
   
   if(NextIndex > 0)
   if(Now < NoTradeData[NextIndex-1] + AfterSecond) result = true;
   if(NextIndex < NoTradeDataCount)
   if(Now >= NoTradeData[NextIndex] - BeforSecond)
   if(Now < NoTradeData[NextIndex]) result = true;
   return(result);
}

void FuncLabelSet(string objname, string text, int size, string font, color textcolor, int x, int y)
{
   if(ObjectFind(objname) == -1) ObjectCreate(objname, OBJ_LABEL, WindowFind(shortname), 0, 0);
   ObjectSetText(objname, text, size, font, textcolor);
   ObjectSet(objname, OBJPROP_CORNER, 0);
   ObjectSet(objname, OBJPROP_XDISTANCE, x);
   ObjectSet(objname, OBJPROP_YDISTANCE, y);
}

void switchEA()
{
   int hwnd = GetAncestor(WindowHandle(Symbol(), Period()), 2);
   PostMessageA(hwnd, WM_COMMAND, 33020, 0);
}